-- -------------------------------------------------------------
-- 
-- File Name: C:\Users\sumanmondal\Desktop\ZZ_intern\example_testing\test\hdlsrc\untitled\untitled_ip_addr_decoder.vhd
-- Created: 2021-03-08 16:59:20
-- 
-- Generated by MATLAB 9.5 and HDL Coder 3.13
-- 
-- -------------------------------------------------------------


-- -------------------------------------------------------------
-- 
-- Module: untitled_ip_addr_decoder
-- Source Path: untitled_ip/untitled_ip_axi_lite/untitled_ip_addr_decoder
-- Hierarchy Level: 2
-- 
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;

ENTITY untitled_ip_addr_decoder IS
  PORT( clk                               :   IN    std_logic;
        reset                             :   IN    std_logic;
        data_write                        :   IN    std_logic_vector(31 DOWNTO 0);  -- ufix32
        addr_sel                          :   IN    std_logic_vector(13 DOWNTO 0);  -- ufix14
        wr_enb                            :   IN    std_logic;  -- ufix1
        rd_enb                            :   IN    std_logic;  -- ufix1
        read_ip_timestamp                 :   IN    std_logic_vector(31 DOWNTO 0);  -- ufix32
        read_Out1                         :   IN    std_logic_vector(15 DOWNTO 0);  -- ufix16_En14
        data_read                         :   OUT   std_logic_vector(31 DOWNTO 0);  -- ufix32
        write_In1                         :   OUT   std_logic_vector(15 DOWNTO 0);  -- ufix16_En15
        write_In2                         :   OUT   std_logic_vector(15 DOWNTO 0)  -- ufix16_En15
        );
END untitled_ip_addr_decoder;


ARCHITECTURE rtl OF untitled_ip_addr_decoder IS

  -- Signals
  SIGNAL enb                              : std_logic;
  SIGNAL addr_sel_unsigned                : unsigned(13 DOWNTO 0);  -- ufix14
  SIGNAL decode_sel_ip_timestamp          : std_logic;  -- ufix1
  SIGNAL read_ip_timestamp_unsigned       : unsigned(31 DOWNTO 0);  -- ufix32
  SIGNAL const_1                          : std_logic;  -- ufix1
  SIGNAL read_Out1_unsigned               : unsigned(15 DOWNTO 0);  -- ufix16_En14
  SIGNAL decode_sel_Out1                  : std_logic;  -- ufix1
  SIGNAL const_0                          : unsigned(31 DOWNTO 0);  -- ufix32
  SIGNAL read_reg_ip_timestamp            : unsigned(31 DOWNTO 0);  -- ufix32
  SIGNAL decode_rd_ip_timestamp           : unsigned(31 DOWNTO 0);  -- ufix32
  SIGNAL read_reg_Out1                    : unsigned(15 DOWNTO 0);  -- ufix16_En14
  SIGNAL data_in_Out1                     : unsigned(31 DOWNTO 0);  -- ufix32
  SIGNAL decode_rd_Out1                   : unsigned(31 DOWNTO 0);  -- ufix32
  SIGNAL decode_sel_In1                   : std_logic;  -- ufix1
  SIGNAL reg_enb_In1                      : std_logic;  -- ufix1
  SIGNAL data_write_unsigned              : unsigned(31 DOWNTO 0);  -- ufix32
  SIGNAL data_in_In1                      : unsigned(15 DOWNTO 0);  -- ufix16_En15
  SIGNAL write_reg_In1                    : unsigned(15 DOWNTO 0);  -- ufix16_En15
  SIGNAL decode_sel_In2                   : std_logic;  -- ufix1
  SIGNAL reg_enb_In2                      : std_logic;  -- ufix1
  SIGNAL data_in_In2                      : unsigned(15 DOWNTO 0);  -- ufix16_En15
  SIGNAL write_reg_In2                    : unsigned(15 DOWNTO 0);  -- ufix16_En15

BEGIN
  addr_sel_unsigned <= unsigned(addr_sel);

  
  decode_sel_ip_timestamp <= '1' WHEN addr_sel_unsigned = to_unsigned(16#0002#, 14) ELSE
      '0';

  read_ip_timestamp_unsigned <= unsigned(read_ip_timestamp);

  const_1 <= '1';

  enb <= const_1;

  read_Out1_unsigned <= unsigned(read_Out1);

  
  decode_sel_Out1 <= '1' WHEN addr_sel_unsigned = to_unsigned(16#0042#, 14) ELSE
      '0';

  const_0 <= to_unsigned(0, 32);

  reg_ip_timestamp_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      read_reg_ip_timestamp <= to_unsigned(0, 32);
    ELSIF clk'EVENT AND clk = '1' THEN
      IF enb = '1' THEN
        read_reg_ip_timestamp <= read_ip_timestamp_unsigned;
      END IF;
    END IF;
  END PROCESS reg_ip_timestamp_process;


  
  decode_rd_ip_timestamp <= const_0 WHEN decode_sel_ip_timestamp = '0' ELSE
      read_reg_ip_timestamp;

  reg_Out1_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      read_reg_Out1 <= to_unsigned(16#0000#, 16);
    ELSIF clk'EVENT AND clk = '1' THEN
      IF enb = '1' THEN
        read_reg_Out1 <= read_Out1_unsigned;
      END IF;
    END IF;
  END PROCESS reg_Out1_process;


  data_in_Out1 <= resize(read_reg_Out1, 32);

  
  decode_rd_Out1 <= decode_rd_ip_timestamp WHEN decode_sel_Out1 = '0' ELSE
      data_in_Out1;

  data_read <= std_logic_vector(decode_rd_Out1);

  
  decode_sel_In1 <= '1' WHEN addr_sel_unsigned = to_unsigned(16#0040#, 14) ELSE
      '0';

  reg_enb_In1 <= decode_sel_In1 AND wr_enb;

  data_write_unsigned <= unsigned(data_write);

  data_in_In1 <= data_write_unsigned(15 DOWNTO 0);

  reg_In1_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      write_reg_In1 <= to_unsigned(16#0000#, 16);
    ELSIF clk'EVENT AND clk = '1' THEN
      IF enb = '1' AND reg_enb_In1 = '1' THEN
        write_reg_In1 <= data_in_In1;
      END IF;
    END IF;
  END PROCESS reg_In1_process;


  write_In1 <= std_logic_vector(write_reg_In1);

  
  decode_sel_In2 <= '1' WHEN addr_sel_unsigned = to_unsigned(16#0041#, 14) ELSE
      '0';

  reg_enb_In2 <= decode_sel_In2 AND wr_enb;

  data_in_In2 <= data_write_unsigned(15 DOWNTO 0);

  reg_In2_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      write_reg_In2 <= to_unsigned(16#0000#, 16);
    ELSIF clk'EVENT AND clk = '1' THEN
      IF enb = '1' AND reg_enb_In2 = '1' THEN
        write_reg_In2 <= data_in_In2;
      END IF;
    END IF;
  END PROCESS reg_In2_process;


  write_In2 <= std_logic_vector(write_reg_In2);

END rtl;

